# dip-bundestag
API des Dokumentations- und Informationssystems für Parlamentsmaterialien

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.2
- Package version: 0.1.1
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

```sh
pip install deutschland[dip_bundestag]
```

### poetry install

```sh
poetry add deutschland -E dip_bundestag
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

## Usage

Import the package:
```python
from deutschland import dip_bundestag
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
from deutschland import dip_bundestag
from pprint import pprint
from deutschland.dip_bundestag.api import aktivitten_api
from deutschland.dip_bundestag.model.aktivitaet import Aktivitaet
from deutschland.dip_bundestag.model.aktivitaet_list_response import AktivitaetListResponse
from deutschland.dip_bundestag.model.get_vorgang404_response import GetVorgang404Response
from deutschland.dip_bundestag.model.get_vorgang_list400_response import GetVorgangList400Response
from deutschland.dip_bundestag.model.get_vorgang_list401_response import GetVorgangList401Response
from deutschland.dip_bundestag.model.zuordnung import Zuordnung
# Defining the host is optional and defaults to https://search.dip.bundestag.de/api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = dip_bundestag.Configuration(
    host = "https://search.dip.bundestag.de/api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyHeader
configuration.api_key['ApiKeyHeader'] = 'YOUR_API_KEY'

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyHeader'] = 'Bearer'

# Configure API key authorization: ApiKeyQuery
configuration.api_key['ApiKeyQuery'] = 'YOUR_API_KEY'

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyQuery'] = 'Bearer'


# Enter a context with an instance of the API client
with dip_bundestag.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = aktivitten_api.AktivittenApi(api_client)
    id = 1 # int | 
    format = "json" # str | Steuert das Datenformat der Antwort, möglich sind JSON (voreingestellt) oder XML. (optional) (default to "json")

    try:
        # Liefert Metadaten zu einer Aktivität
        api_response = api_instance.get_aktivitaet(id, format=format)
        pprint(api_response)
    except dip_bundestag.ApiException as e:
        print("Exception when calling AktivittenApi->get_aktivitaet: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://search.dip.bundestag.de/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AktivittenApi* | [**get_aktivitaet**](docs/AktivittenApi.md#get_aktivitaet) | **GET** /aktivitaet/{id} | Liefert Metadaten zu einer Aktivität
*AktivittenApi* | [**get_aktivitaet_list**](docs/AktivittenApi.md#get_aktivitaet_list) | **GET** /aktivitaet | Liefert eine Liste von Metadaten zu Aktivitäten
*DrucksachenApi* | [**get_drucksache**](docs/DrucksachenApi.md#get_drucksache) | **GET** /drucksache/{id} | Liefert Metadaten zu einer Drucksache
*DrucksachenApi* | [**get_drucksache_list**](docs/DrucksachenApi.md#get_drucksache_list) | **GET** /drucksache | Liefert eine Liste von Metadaten zu Drucksachen
*DrucksachenApi* | [**get_drucksache_text**](docs/DrucksachenApi.md#get_drucksache_text) | **GET** /drucksache-text/{id} | Liefert Volltext und Metadaten zu einer Drucksache
*DrucksachenApi* | [**get_drucksache_text_list**](docs/DrucksachenApi.md#get_drucksache_text_list) | **GET** /drucksache-text | Liefert eine Liste von Volltexten und Metadaten zu Drucksachen
*PersonenstammdatenApi* | [**get_person**](docs/PersonenstammdatenApi.md#get_person) | **GET** /person/{id} | Liefert Personenstammdaten zu einer Person
*PersonenstammdatenApi* | [**get_person_list**](docs/PersonenstammdatenApi.md#get_person_list) | **GET** /person | Liefert eine Liste von Personenstammdaten
*PlenarprotokolleApi* | [**get_plenarprotokoll**](docs/PlenarprotokolleApi.md#get_plenarprotokoll) | **GET** /plenarprotokoll/{id} | Liefert Metadaten zu einem Plenarprotokoll
*PlenarprotokolleApi* | [**get_plenarprotokoll_list**](docs/PlenarprotokolleApi.md#get_plenarprotokoll_list) | **GET** /plenarprotokoll | Liefert eine Liste von Metadaten zu Plenarprotokollen
*PlenarprotokolleApi* | [**get_plenarprotokoll_text**](docs/PlenarprotokolleApi.md#get_plenarprotokoll_text) | **GET** /plenarprotokoll-text/{id} | Liefert Volltext und Metadaten zu einem Plenarprotokoll
*PlenarprotokolleApi* | [**get_plenarprotokoll_text_list**](docs/PlenarprotokolleApi.md#get_plenarprotokoll_text_list) | **GET** /plenarprotokoll-text | Liefert eine Liste von Volltexten und Metadaten zu Plenarprotokollen
*VorgangspositionenApi* | [**get_vorgangsposition**](docs/VorgangspositionenApi.md#get_vorgangsposition) | **GET** /vorgangsposition/{id} | Liefert Metadaten zu einer Vorgangsposition
*VorgangspositionenApi* | [**get_vorgangsposition_list**](docs/VorgangspositionenApi.md#get_vorgangsposition_list) | **GET** /vorgangsposition | Liefert eine Liste von Metadaten zu Vorgangspositionen
*VorgngeApi* | [**get_vorgang**](docs/VorgngeApi.md#get_vorgang) | **GET** /vorgang/{id} | Liefert Metadaten zu einem Vorgang
*VorgngeApi* | [**get_vorgang_list**](docs/VorgngeApi.md#get_vorgang_list) | **GET** /vorgang | Liefert eine Liste von Metadaten zu Vorgängen


## Documentation For Models

 - [Aktivitaet](docs/Aktivitaet.md)
 - [AktivitaetAnzeige](docs/AktivitaetAnzeige.md)
 - [AktivitaetListResponse](docs/AktivitaetListResponse.md)
 - [AktivitaetListResponseAllOf](docs/AktivitaetListResponseAllOf.md)
 - [Beschlussfassung](docs/Beschlussfassung.md)
 - [Bundesland](docs/Bundesland.md)
 - [Deskriptor](docs/Deskriptor.md)
 - [DokumentTextBase](docs/DokumentTextBase.md)
 - [Drucksache](docs/Drucksache.md)
 - [DrucksacheAutorenAnzeigeInner](docs/DrucksacheAutorenAnzeigeInner.md)
 - [DrucksacheListResponse](docs/DrucksacheListResponse.md)
 - [DrucksacheListResponseAllOf](docs/DrucksacheListResponseAllOf.md)
 - [DrucksacheText](docs/DrucksacheText.md)
 - [DrucksacheTextListResponse](docs/DrucksacheTextListResponse.md)
 - [DrucksacheTextListResponseAllOf](docs/DrucksacheTextListResponseAllOf.md)
 - [Fundstelle](docs/Fundstelle.md)
 - [GetVorgang404Response](docs/GetVorgang404Response.md)
 - [GetVorgangList400Response](docs/GetVorgangList400Response.md)
 - [GetVorgangList401Response](docs/GetVorgangList401Response.md)
 - [Inkrafttreten](docs/Inkrafttreten.md)
 - [ListResponseBase](docs/ListResponseBase.md)
 - [Person](docs/Person.md)
 - [PersonListResponse](docs/PersonListResponse.md)
 - [PersonListResponseAllOf](docs/PersonListResponseAllOf.md)
 - [PersonRole](docs/PersonRole.md)
 - [Plenarprotokoll](docs/Plenarprotokoll.md)
 - [PlenarprotokollListResponse](docs/PlenarprotokollListResponse.md)
 - [PlenarprotokollListResponseAllOf](docs/PlenarprotokollListResponseAllOf.md)
 - [PlenarprotokollText](docs/PlenarprotokollText.md)
 - [PlenarprotokollTextListResponse](docs/PlenarprotokollTextListResponse.md)
 - [PlenarprotokollTextListResponseAllOf](docs/PlenarprotokollTextListResponseAllOf.md)
 - [Quadrant](docs/Quadrant.md)
 - [Ressort](docs/Ressort.md)
 - [Ueberweisung](docs/Ueberweisung.md)
 - [Urheber](docs/Urheber.md)
 - [Verkuendung](docs/Verkuendung.md)
 - [Vorgang](docs/Vorgang.md)
 - [VorgangDeskriptor](docs/VorgangDeskriptor.md)
 - [VorgangDeskriptorAllOf](docs/VorgangDeskriptorAllOf.md)
 - [VorgangListResponse](docs/VorgangListResponse.md)
 - [VorgangListResponseAllOf](docs/VorgangListResponseAllOf.md)
 - [VorgangVerlinkung](docs/VorgangVerlinkung.md)
 - [Vorgangsbezug](docs/Vorgangsbezug.md)
 - [Vorgangsposition](docs/Vorgangsposition.md)
 - [VorgangspositionListResponse](docs/VorgangspositionListResponse.md)
 - [VorgangspositionListResponseAllOf](docs/VorgangspositionListResponseAllOf.md)
 - [Vorgangspositionbezug](docs/Vorgangspositionbezug.md)
 - [VorgangspositionbezugAllOf](docs/VorgangspositionbezugAllOf.md)
 - [Zuordnung](docs/Zuordnung.md)


## Documentation For Authorization


## ApiKeyHeader

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## ApiKeyQuery

- **Type**: API key
- **API key parameter name**: apikey
- **Location**: URL query string


## Author

parlamentsdokumentation@bundestag.de


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in dip_bundestag.apis and dip_bundestag.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from deutschland.dip_bundestag.api.default_api import DefaultApi`
- `from deutschland.dip_bundestag.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
from deutschland import dip_bundestag
from deutschland.dip_bundestag.apis import *
from deutschland.dip_bundestag.models import *
```

